Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3069)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3083)
@@ -1659,28 +1858,28 @@
        IF ( orientation ) THEN  !if array is oriented upwards
           DO  jj = 0, rad_j
-             shortest_distance = MIN( shortest_distance,                        &
-                                      SQRT( MAX(pos_i*dx-0.5*dx,0.0)**2         &
-                                          + MAX(jj*dy-0.5*dy,0.0)**2            &
-                                          + MAX(zw(loc_k(jj)+k-1)-zu(k),0.0)**2 &
-                                          )                                     &
-                                    )
+             shortest_distance =                                               &
+                MIN( shortest_distance,                                        &
+                     SQRT( MAX(REAL(pos_i, KIND=wp)*dx-0.5_wp*dx, 0.0_wp)**2   &
+                         + MAX(REAL(jj, KIND=wp)*dy-0.5_wp*dy, 0.0_wp)**2      &
+                         + MAX(zw(loc_k(jj)+k-1)-zu(k), 0.0_wp)**2             &
+                         )                                                     &
+                   )
           ENDDO
        ELSE  !if array is oriented downwards
-          !## NOTE: MAX within zw required to circumvent error at domain border
-          !##  At the domain border, if non-cyclic boundary is present, the
-          !##  index for zw could be -1, which will be errorneous (zw(-1) does
-          !##  not exist). The MAX function limits the index to be at least 0.
+          !> @note MAX within zw required to circumvent error at domain border
+          !>   At the domain border, if non-cyclic boundary is present, the
+          !>   index for zw could be -1, which will be errorneous (zw(-1) does
+          !>   not exist). The MAX function limits the index to be at least 0.
           DO  jj = 0, rad_j
-             shortest_distance = MIN( shortest_distance,                       &
-                                      SQRT( MAX(pos_i*dx-0.5*dx,0.0)**2        &
-                                          + MAX(jj*dy-0.5*dy,0.0)**2           &
-                                          + MAX(zu(k)-zw(MAX(k-loc_k(jj),      &
-                                                             0_iwp)),          &
-                                                0.0)**2                        &
-                                          )                                    &
-                                    )
+             shortest_distance =                                               &
+                MIN( shortest_distance,                                        &
+                     SQRT( MAX(REAL(pos_i, KIND=wp)*dx-0.5_wp*dx, 0.0_wp)**2   &
+                         + MAX(REAL(jj, KIND=wp)*dy-0.5_wp*dy, 0.0_wp)**2      &
+                         + MAX(zu(k)-zw(MAX(k-loc_k(jj),0_iwp)), 0.0_wp)**2    &
+                         )                                                     &
+                   )
           ENDDO
        ENDIF
-
+       
     END FUNCTION
 
@@ -2004,4 +2203,6 @@
 !
 !--    Use special boundary condition in case of TKE-e closure
+       !> @todo do the same for usm and lsm surfaces
+       !>   2018-06-05, gronemeier
        IF ( rans_tke_e )  THEN
           DO  i = nxl, nxr
@@ -2011,5 +2212,5 @@
                 DO  m = surf_s, surf_e
                    k = surf_def_h(0)%k(m)
-                   e_p(k,j,i) = surf_def_h(0)%us(m)**2 / c_m**2
+                   e_p(k,j,i) = surf_def_h(0)%us(m)**2 / c_0**2
                 ENDDO
              ENDDO
@@ -2092,5 +2293,5 @@
              DO  k = nzb+1, nzt
 !                tend(k,j,i) = tend(k,j,i) + c_1 * diss(k,j,i) / ( e(k,j,i) + 1.0E-20_wp ) * produc(k)
-                tend(k,j,i) = tend(k,j,i) + c_1 * c_mu * f / c_h               &  !### needs revision
+                tend(k,j,i) = tend(k,j,i) + c_1 * c_0**4 * f / c_4               &  !> @todo needs revision
                       / surf_def_h(0)%us(surf_def_h(0)%start_index(j,i))       &
                       * SQRT(e(k,j,i)) * produc(k,j,i)
@@ -2103,7 +2304,7 @@
 !
 !--    Additional sink term for flows through plant canopies
-!        IF ( plant_canopy )  CALL pcm_tendency( ? )                            !### what to do with this?
-
-!        CALL user_actions( 'diss-tendency' )                                   !### not yet implemented
+!        IF ( plant_canopy )  CALL pcm_tendency( ? )                            !> @query what to do with this?
+
+!        CALL user_actions( 'diss-tendency' )                                   !> @todo not yet implemented
 
 !
@@ -2181,8 +2382,12 @@
     USE arrays_3d,                                                             &
         ONLY:  ddzu, diss_l_diss, diss_l_e, diss_s_diss, diss_s_e,             &
-               flux_l_diss, flux_l_e, flux_s_diss, flux_s_e
+               flux_l_diss, flux_l_e, flux_s_diss, flux_s_e,&
+               u_p,v_p,w_p
 
     USE control_parameters,                                                    &
         ONLY:  f, tsc
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
 
     USE surface_mod,                                                           &
@@ -2190,17 +2395,30 @@
                 surf_usm_v 
 
+    use indices, only: nx, ny
+
     IMPLICIT NONE
 
     INTEGER(iwp) ::  i       !< loop index x direction
-    INTEGER(iwp) ::  i_omp   !< 
+    INTEGER(iwp) ::  i_omp   !< first loop index of i-loop in prognostic_equations
     INTEGER(iwp) ::  j       !< loop index y direction
     INTEGER(iwp) ::  k       !< loop index z direction
+    INTEGER(iwp) ::  l       !< loop index
     INTEGER(iwp) ::  m       !< loop index
     INTEGER(iwp) ::  surf_e  !< end index of surface elements at given i-j position
     INTEGER(iwp) ::  surf_s  !< start index of surface elements at given i-j position
-    INTEGER(iwp) ::  tn      !<
-
-    REAL(wp), DIMENSION(nzb:nzt+1) :: advec  !< advection term of TKE tendency
-    REAL(wp), DIMENSION(nzb:nzt+1) :: produc !< production term of TKE tendency
+    INTEGER(iwp) ::  tn      !< task number of openmp task
+
+    INTEGER(iwp) :: pis = 32 !< debug variable, print from i=pis                !> @todo remove later
+    INTEGER(iwp) :: pie = 32 !< debug variable, print until i=pie               !> @todo remove later
+    INTEGER(iwp) :: pjs = 26 !< debug variable, print from j=pjs                !> @todo remove later
+    INTEGER(iwp) :: pje = 26 !< debug variable, print until j=pje               !> @todo remove later
+    INTEGER(iwp) :: pkb = 1  !< debug variable, print from k=pkb                !> @todo remove later
+    INTEGER(iwp) :: pkt = 7  !< debug variable, print until k=pkt               !> @todo remove later
+
+    REAL(wp), DIMENSION(nzb:nzt+1) :: dum_adv   !< debug variable               !> @todo remove later
+    REAL(wp), DIMENSION(nzb:nzt+1) :: dum_pro   !< debug variable               !> @todo remove later
+    REAL(wp), DIMENSION(nzb:nzt+1) :: dum_dif   !< debug variable               !> @todo remove later
+
+5555 FORMAT(A,7(1X,E12.5))   !> @todo remove later
 
 !
@@ -2224,9 +2442,9 @@
        ENDIF
 
-       advec(:) = tend(:,j,i)
-
-       CALL production_e( i, j )
-
-       produc(:) = tend(:,j,i) - advec(:)
+       dum_adv = tend(:,j,i)                                                    !> @todo remove later
+
+       CALL production_e( i, j, .FALSE. )
+
+       dum_pro = tend(:,j,i) - dum_adv                                          !> @todo remove later
 
        IF ( .NOT. humidity )  THEN
@@ -2239,4 +2457,6 @@
           CALL diffusion_e( i, j, vpt, pt_reference )
        ENDIF
+
+       dum_dif = tend(:,j,i) - dum_adv - dum_pro                                !> @todo remove later
 
 !
@@ -2268,5 +2488,14 @@
           DO  m = surf_s, surf_e
              k = surf_def_h(0)%k(m)
-             e_p(k,j,i) = surf_def_h(0)%us(m)**2 / c_m**2
+             e_p(k,j,i) = ( surf_def_h(0)%us(m) / c_0 )**2
+          ENDDO
+
+          DO  l = 0, 3
+             surf_s = surf_def_v(l)%start_index(j,i)
+             surf_e = surf_def_v(l)%end_index(j,i)
+             DO  m = surf_s, surf_e
+                k = surf_def_v(l)%k(m)
+                e_p(k,j,i) = ( surf_def_v(l)%us(m) / c_0 )**2
+             ENDDO
           ENDDO
        ENDIF
@@ -2287,4 +2516,21 @@
           ENDIF
        ENDIF
+
+!        if ( i >= pis .and. i <= pie .and. j >= pjs .and. j <= pje ) then        !> @todo remove later
+!           WRITE(9, *) '------'
+!           WRITE(9, '(A,F8.3,1X,F8.3,1X,I2)') 't, dt, int_ts:', simulated_time, dt_3d, intermediate_timestep_count
+!           WRITE(9, *) 'i:', i
+!           WRITE(9, *) 'j:', j
+!           WRITE(9, *) 'k:', pkb, ' - ', pkt
+!           WRITE(9, *) '---'
+!           WRITE(9, *) 'e:'
+!           WRITE(9, 5555) 'adv :', dum_adv(pkb:pkt)
+!           WRITE(9, 5555) 'pro :', dum_pro(pkb:pkt)
+!           WRITE(9, 5555) 'dif :', dum_dif(pkb:pkt)
+!           WRITE(9, 5555) 'tend:', tend(pkb:pkt,j,i)
+!           WRITE(9, 5555) 'e_p :', e_p(pkb:pkt,j,i)
+!           WRITE(9, 5555) 'e   :', e(pkb:pkt,j,i)
+!           FLUSH(9)
+!        endif
 
     ENDIF   ! TKE equation
@@ -2309,20 +2555,34 @@
        ENDIF
 
+       IF ( intermediate_timestep_count == 1 )  diss_adve1(:,j,i) = tend(:,j,i) !> @todo remove later
+       IF ( intermediate_timestep_count == 2 )  diss_adve2(:,j,i) = tend(:,j,i)
+       IF ( intermediate_timestep_count == 3 )  diss_adve3(:,j,i) = tend(:,j,i)
+
 !
 !--    Production of TKE dissipation rate
-       DO  k = nzb+1, nzt
-!              tend(k,j,i) = tend(k,j,i) + c_1 * diss(k,j,i) / ( e(k,j,i) + 1.0E-20_wp ) * produc(k)
-          tend(k,j,i) = tend(k,j,i) + c_1 * c_mu * f / c_h                     &  !### needs revision
-                      / surf_def_h(0)%us(surf_def_h(0)%start_index(j,i))       &
-                      * SQRT(e(k,j,i)) * produc(k)
-       ENDDO
-
+       CALL production_e( i, j, .TRUE. )
+
+       IF ( intermediate_timestep_count == 1 )  diss_prod1(:,j,i) = tend(:,j,i) - diss_adve1(:,j,i) !> @todo remove later
+       IF ( intermediate_timestep_count == 2 )  diss_prod2(:,j,i) = tend(:,j,i) - diss_adve2(:,j,i)
+       IF ( intermediate_timestep_count == 3 )  diss_prod3(:,j,i) = tend(:,j,i) - diss_adve3(:,j,i)
+
+       dum_pro = tend(:,j,i) - dum_adv                                          !> @todo remove later
+
+!
+!--    Diffusion term of TKE dissipation rate
        CALL diffusion_diss( i, j )
 
+       IF ( intermediate_timestep_count == 1 )  diss_diff1(:,j,i) = tend(:,j,i) - diss_adve1(:,j,i) - diss_prod1(:,j,i) !> @todo remove later
+       IF ( intermediate_timestep_count == 2 )  diss_diff2(:,j,i) = tend(:,j,i) - diss_adve2(:,j,i) - diss_prod2(:,j,i)
+       IF ( intermediate_timestep_count == 3 )  diss_diff3(:,j,i) = tend(:,j,i) - diss_adve3(:,j,i) - diss_prod3(:,j,i)
+       IF ( intermediate_timestep_count == 3 )  dummy3(:,j,i) = km(:,j,i)
+
+       dum_dif = tend(:,j,i) - dum_adv - dum_pro                                !> @todo remove later
+
 !
 !--    Additional sink term for flows through plant canopies
-!        IF ( plant_canopy )  CALL pcm_tendency( i, j, ? )                      !### not yet implemented
-
-!        CALL user_actions( i, j, 'diss-tendency' )                             !### not yet implemented
+!        IF ( plant_canopy )  CALL pcm_tendency( i, j, ? )                      !> @todo not yet implemented
+
+!        CALL user_actions( i, j, 'diss-tendency' )                             !> @todo not yet implemented
 
 !
@@ -2338,5 +2598,4 @@
                                                 BTEST( wall_flags_0(k,j,i), 0 )&
                                                )
-          IF ( diss_p(k,j,i) <= 0.0_wp )  diss_p(k,j,i) = 0.1_wp * diss(k,j,i)
        ENDDO
 
@@ -2350,4 +2609,21 @@
        ENDDO
 
+       DO  l = 0, 1
+          surf_s = surf_def_v(l)%start_index(j,i)
+          surf_e = surf_def_v(l)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k = surf_def_v(l)%k(m)
+             diss_p(k,j,i) = surf_def_v(l)%us(m)**3 / ( kappa * 0.5_wp * dy )
+          ENDDO
+       ENDDO
+
+       DO  l = 2, 3
+          surf_s = surf_def_v(l)%start_index(j,i)
+          surf_e = surf_def_v(l)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k = surf_def_v(l)%k(m)
+             diss_p(k,j,i) = surf_def_v(l)%us(m)**3 / ( kappa * 0.5_wp * dx )
+          ENDDO
+       ENDDO
 !
 !--    Calculate tendencies for the next Runge-Kutta step
@@ -2365,8 +2641,30 @@
           ENDIF
        ENDIF
-
-!        IF ( intermediate_timestep_count == 1 )  dummy1(:,j,i) = e_p(:,j,i)
-!        IF ( intermediate_timestep_count == 2 )  dummy2(:,j,i) = e_p(:,j,i)
-!        IF ( intermediate_timestep_count == 3 )  dummy3(:,j,i) = e_p(:,j,i)
+!
+!--    Limit change of diss to be between -90% and +100%. Also, set an absolute
+!--    minimum value
+       DO  k = nzb, nzt+1
+          diss_p(k,j,i) = MIN( MAX( diss_p(k,j,i),         &
+                                    0.1_wp * diss(k,j,i),  &
+                                    0.0001_wp ),           &
+                               2.0_wp * diss(k,j,i) )
+       ENDDO
+
+       IF ( intermediate_timestep_count == 1 )  dummy1(:,j,i) = diss_p(:,j,i)   !> @todo remove later
+       IF ( intermediate_timestep_count == 2 )  dummy2(:,j,i) = diss_p(:,j,i)
+
+!        if ( i >= pis .and. i <= pie .and. j >= pjs .and. j <= pje ) then        !> @todo remove later
+!           WRITE(9, *) '---'
+!           WRITE(9, *) 'diss:'
+!           WRITE(9, 5555) 'adv   :', dum_adv(pkb:pkt)
+!           WRITE(9, 5555) 'pro   :', dum_pro(pkb:pkt)
+!           WRITE(9, 5555) 'dif   :', dum_dif(pkb:pkt)
+!           WRITE(9, 5555) 'tend  :', tend(pkb:pkt,j,i)
+!           WRITE(9, 5555) 'diss_p:', diss_p(pkb:pkt,j,i)
+!           WRITE(9, 5555) 'diss  :', diss(pkb:pkt,j,i)
+!           WRITE(9, *) '---'
+!           WRITE(9, 5555) 'km    :', km(pkb:pkt,j,i)
+!           flush(9)
+!        endif
 
     ENDIF   ! dissipation equation
@@ -2382,4 +2680,5 @@
 !> @warning The case with constant_flux_layer = F and use_surface_fluxes = T is
 !>          not considered well!
+!> @todo Adjust production term in case of rans_tke_e simulation
 !------------------------------------------------------------------------------!
  SUBROUTINE production_e
@@ -3099,6 +3398,7 @@
 !> @warning The case with constant_flux_layer = F and use_surface_fluxes = T is
 !>          not considered well!
+!> @todo non-neutral case is not yet considered for RANS mode
 !------------------------------------------------------------------------------!
- SUBROUTINE production_e_ij( i, j )
+ SUBROUTINE production_e_ij( i, j, diss_production )
 
     USE arrays_3d,                                                             &
@@ -3121,4 +3421,6 @@
 
     IMPLICIT NONE
+
+    LOGICAL :: diss_production
 
     INTEGER(iwp) ::  i       !< running index x-direction
@@ -3153,5 +3455,5 @@
     REAL(wp), DIMENSION(nzb+1:nzt)  ::  dwdy        !< Gradient of w-component in y-direction
     REAL(wp), DIMENSION(nzb+1:nzt)  ::  dwdz        !< Gradient of w-component in z-direction
-
+    REAL(wp), DIMENSION(nzb+1:nzt)  ::  tend_temp   !< temporal tendency
 
     IF ( constant_flux_layer )  THEN
@@ -3348,23 +3650,14 @@
        ENDDO
 
+!        IF ( .NOT. rans_tke_e )  THEN
+
        DO  k = nzb+1, nzt
 
-          def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) +            &
-                           dudy(k)**2 + dvdx(k)**2 + dwdx(k)**2   +            &
-                           dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2   +            &
-                2.0_wp * ( dvdx(k)*dudy(k) + dwdx(k)*dudz(k) + dwdy(k)*dvdz(k) )
-
-!
-!--       Production term according to Kato and Launder (1993)
-!           def = SQRT( ( dudx(k) + dudy(k) + dudz(k) +                       &
-!                         dvdx(k) + dvdy(k) + dvdz(k) +                       &
-!                         dwdx(k) + dwdy(k) + dwdz(k)                         &
-!                       )**4 -                                                &
-!                       ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 +              &
-!                         2.0_wp * ( dudy(k) * dvdx(k) +                      &
-!                                    dudz(k) * dwdx(k) +                      &
-!                                    dvdz(k) * dwdy(k) )                      &
-!                       )**2                                                  &
-!                     )
+          def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) +         &
+                           dudy(k)**2 + dvdx(k)**2 + dwdx(k)**2   +         &
+                           dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2   +         &
+                2.0_wp * ( dvdx(k)*dudy(k) +                                &
+                           dwdx(k)*dudz(k) +                                &
+                           dwdy(k)*dvdz(k) )
 
           IF ( def < 0.0_wp )  def = 0.0_wp
@@ -3372,59 +3665,150 @@
           flag  = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) ) 
 
-          tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def * flag
+          tend_temp(k) = km(k,j,i) * def * flag
 
        ENDDO
 
+!        ELSE
+! 
+!           DO  k = nzb+1, nzt
+! !
+! !--          Production term according to Kato and Launder (1993)
+!              def = SQRT( ( dudy(k)**2 + dvdz(k)**2 + dwdx(k)**2 +              &
+!                            dudz(k)**2 + dvdx(k)**2 + dwdy(k)**2 +              &
+!                            2.0_wp * ( dudy(k) * dvdx(k) +                      &
+!                                       dvdz(k) * dwdy(k) +                      &
+!                                       dwdx(k) * dudz(k) )       )              &
+!                        * ( dudy(k)**2 + dvdz(k)**2 + dwdx(k)**2 +              &
+!                            dudz(k)**2 + dvdx(k)**2 + dwdy(k)**2 -              &
+!                            2.0_wp * ( dudy(k) * dvdx(k) +                      &
+!                                       dvdz(k) * dwdy(k) +                      &
+!                                       dwdx(k) * dudz(k) )       )              &
+!                        )
+! 
+!              IF ( def < 0.0_wp )  def = 0.0_wp
+! 
+!              flag  = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) ) 
+! 
+!              tend_temp(k) = km(k,j,i) * def * flag
+! 
+!           ENDDO
+! 
+!        ENDIF
+
+    ELSE  ! not constant_flux_layer
+
+!        IF ( .NOT. rans_tke_e )  THEN
+!
+!--       Calculate TKE production by shear. Here, no additional
+!--       wall-bounded code is considered. 
+!--       Why?
+          DO  k = nzb+1, nzt
+
+             dudx(k)  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
+             dudy(k)  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) -                &
+                                    u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
+             dudz(k)  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) -                &
+                                    u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
+
+             dvdx(k)  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) -                &
+                                    v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
+             dvdy(k)  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
+             dvdz(k)  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -                &
+                                    v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
+
+             dwdx(k)  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -                &
+                                    w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
+             dwdy(k)  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) -                &
+                                    w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
+             dwdz(k)  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
+
+             def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) +         &
+                              dudy(k)**2 + dvdx(k)**2 + dwdx(k)**2   +         &
+                              dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2   +         &
+                   2.0_wp * ( dvdx(k)*dudy(k) +                                &
+                              dwdx(k)*dudz(k) +                                &
+                              dwdy(k)*dvdz(k) )
+
+             IF ( def < 0.0_wp )  def = 0.0_wp
+
+             flag        = MERGE( 1.0_wp, 0.0_wp,                              &
+                                  BTEST( wall_flags_0(k,j,i), 29 ) ) 
+             tend_temp(k) = km(k,j,i) * def * flag
+
+          ENDDO
+
+!        ELSE
+! 
+!           DO  k = nzb+1, nzt
+! 
+!              dudx(k)  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
+!              dudy(k)  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) -                &
+!                                     u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
+!              dudz(k)  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) -                &
+!                                     u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
+! 
+!              dvdx(k)  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) -                &
+!                                     v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
+!              dvdy(k)  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
+!              dvdz(k)  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -                &
+!                                     v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
+! 
+!              dwdx(k)  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -                &
+!                                     w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
+!              dwdy(k)  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) -                &
+!                                     w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
+!              dwdz(k)  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
+! !
+! !--          Production term according to Kato and Launder (1993)
+!              def = SQRT( ( dudy(k)**2 + dvdz(k)**2 + dwdx(k)**2 +              &
+!                            dudz(k)**2 + dvdx(k)**2 + dwdy(k)**2 +              &
+!                            2.0_wp * ( dudy(k) * dvdx(k) +                      &
+!                                       dvdz(k) * dwdy(k) +                      &
+!                                       dwdx(k) * dudz(k) )       )              &
+!                        * ( dudy(k)**2 + dvdz(k)**2 + dwdx(k)**2 +              &
+!                            dudz(k)**2 + dvdx(k)**2 + dwdy(k)**2 -              &
+!                            2.0_wp * ( dudy(k) * dvdx(k) +                      &
+!                                       dvdz(k) * dwdy(k) +                      &
+!                                       dwdx(k) * dudz(k) )       )              &
+!                        )
+! 
+!              IF ( def < 0.0_wp )  def = 0.0_wp
+! 
+!              flag        = MERGE( 1.0_wp, 0.0_wp,                              &
+!                                   BTEST( wall_flags_0(k,j,i), 29 ) ) 
+!              tend_temp(k) = km(k,j,i) * def * flag
+! 
+!           ENDDO
+! 
+!        ENDIF
+
+    ENDIF
+
+    IF ( .NOT. diss_production )  THEN
+!
+!--    Production term in case of TKE production
+       DO  k = nzb+1, nzt
+          tend(k,j,i) = tend(k,j,i) + tend_temp(k)
+       ENDDO
     ELSE
 !
-!--    Calculate TKE production by shear. Here, no additional
-!--    wall-bounded code is considered. 
-!--    Why?
+!--    Production term in case of dissipation-rate production (rans_tke_e)
        DO  k = nzb+1, nzt
 
-          dudx(k)  =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-          dudy(k)  = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) -                   &
-                                 u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-          dudz(k)  = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) -                   &
-                                 u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-          dvdx(k)  = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) -                   &
-                                 v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
-          dvdy(k)  =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-          dvdz(k)  = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -                   &
-                                 v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-          dwdx(k)  = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -                   &
-                                 w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-          dwdy(k)  = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) -                   &
-                                 w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
-          dwdz(k)  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
-
-          def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) +            &
-                           dudy(k)**2 + dvdx(k)**2 + dwdx(k)**2   +            &
-                           dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2   +            &
-                2.0_wp * ( dvdx(k)*dudy(k) + dwdx(k)*dudz(k) + dwdy(k)*dvdz(k) )
-
-!
-!--       Production term according to Kato and Launder (1993)
-!           def = SQRT( ( dudx(k) + dudy(k) + dudz(k) +                        &
-!                         dvdx(k) + dvdy(k) + dvdz(k) +                        &
-!                         dwdx(k) + dwdy(k) + dwdz(k)                          &
-!                       )**4 -                                                 &
-!                       ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 +               &
-!                         2.0_wp * ( dudy(k) * dvdx(k) +                       &
-!                                    dudz(k) * dwdx(k) +                       &
-!                                    dvdz(k) * dwdy(k) )                       &
-!                       )**2                                                   &
-!                     )
-
-          IF ( def < 0.0_wp )  def = 0.0_wp
-
-          flag        = MERGE( 1.0_wp, 0.0_wp,                                 &
-                               BTEST( wall_flags_0(k,j,i), 29 ) ) 
-          tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def * flag
-
+          ! Standard TKE-e closure
+          tend(k,j,i) = tend(k,j,i) + tend_temp(k) * diss(k,j,i)               &
+                                    /( e(k,j,i) + 1.0E-20_wp )                 &
+                                    * c_1
+!           ! Production according to Koblitz (2013)
+!           tend(k,j,i) = tend(k,j,i) + tend_temp(k) * diss(k,j,i)               &
+!                                     /( e(k,j,i) + 1.0E-20_wp )                 &
+!                                     * ( c_1 + ( c_2 - c_1 )                    &
+!                                             * l_wall(k,j,i) / l_max )
+!           ! Production according to Detering and Etling (1985)
+!           !> @todo us is not correct if there are vertical walls
+!           tend(k,j,i) = tend(k,j,i) + tend_temp(k) * SQRT(e(k,j,i))            &
+!                                     * c_1 * c_0**3 / c_4 * f                   &
+!              / surf_def_h(0)%us(surf_def_h(0)%start_index(j,i))
        ENDDO
-
     ENDIF
 
@@ -3822,10 +4206,10 @@
     REAL(wp)     ::  l              !< mixing length
     REAL(wp)     ::  ll             !< adjusted l
-    REAL(wp)     ::  var_reference  !< 
+    REAL(wp)     ::  var_reference  !< reference temperature
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !< 
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !< temperature
 #else
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  var  !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  var  !< temperature
 #endif
     REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  dissipation  !< TKE dissipation
@@ -3837,4 +4221,7 @@
        DO  j = nys, nyn
           DO  k = nzb+1, nzt
+!
+!--          Predetermine flag to mask topography
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
 !
@@ -3851,5 +4238,7 @@
                 CALL mixing_length_rans( i, j, k, l, ll, var, var_reference )
 
-                dissipation(k,j) = c_m**3 * e(k,j,i) * SQRT( e(k,j,i) ) / ll
+                dissipation(k,j) = c_0**3 * e(k,j,i) * SQRT( e(k,j,i) ) / ll
+
+                diss(k,j,i) = dissipation(k,j) * flag
 
              ELSEIF ( rans_tke_e )  THEN
@@ -3859,23 +4248,20 @@
              ENDIF
 
-!
-!--          Predetermine flag to mask topography
-             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
-
-             tend(k,j,i) = tend(k,j,i)                                         &
-                                     + (                                       &
+             tend(k,j,i) = tend(k,j,i) + (                                     &
+                                           (                                   &
                        ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )     &
                      - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )     &
-                                       ) * ddx2  * flag                        &
-                                     + (                                       &
+                                           ) * ddx2  * flag                    &
+                                         + (                                   &
                        ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )     &
                      - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )     &
-                                       ) * ddy2  * flag                        &
-                                     + (                                       &
+                                           ) * ddy2  * flag                    &
+                                         + (                                   &
             ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1)    &
                                                           * rho_air_zw(k)      &
           - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)      &
                                                           * rho_air_zw(k-1)    &
-                                       ) * ddzw(k) * drho_air(k) * flag        &
+                                           ) * ddzw(k) * drho_air(k)           &
+                                         ) * flag * dsig_e                     &
                           - dissipation(k,j) * flag
 
@@ -3959,10 +4345,10 @@
     REAL(wp)     ::  l              !< mixing length
     REAL(wp)     ::  ll             !< adjusted l
-    REAL(wp)     ::  var_reference  !< 
+    REAL(wp)     ::  var_reference  !< reference temperature
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !<
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !< temperature
 #else
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  var     !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  var     !< temperature
 #endif
     REAL(wp), DIMENSION(nzb+1:nzt) ::  dissipation  !< dissipation of TKE
@@ -3991,5 +4377,7 @@
           CALL mixing_length_rans( i, j, k, l, ll, var, var_reference  )
 
-          dissipation(k) = c_m**3 * e(k,j,i) * SQRT( e(k,j,i) ) / ll
+          dissipation(k) = c_0**3 * e(k,j,i) * SQRT( e(k,j,i) ) / ll
+
+          diss(k,j,i) = dissipation(k) * flag
 
        ELSEIF ( rans_tke_e )  THEN
